﻿Option Explicit On

Imports System.Diagnostics

Module modErrorHandler
    Public Sub ErrorHandler(Optional ByVal DisplayErrorMsg As String = "", _
                            Optional ByVal DisplayMsgBoxStyle As MsgBoxStyle = MsgBoxStyle.OkOnly, _
                            Optional ByVal bDisplayMsgBox As Boolean = True)

        Dim st As System.Diagnostics.StackTrace = New System.Diagnostics.StackTrace(1)
        Dim sf As System.Diagnostics.StackFrame = st.GetFrame(0)
        Dim ErrorMsg As String = "Error: " + sf.GetMethod().DeclaringType.FullName + "." + sf.GetMethod().Name

        ' Error Exception
        Dim ErrException As Exception = Err.GetException
        If ErrException IsNot Nothing Then
            ErrorMsg += ErrException.StackTrace + vbNewLine
        End If

        ' Error number and description
        ErrorMsg += "Error: " + CStr(Err.Number) + "  " + Err.Description + vbNewLine

        Console.WriteLine(ErrorMsg)
        If Err.Number <> 0 Then
            Console.WriteLine(Err.Number.ToString + ": " + Err.Description)
        End If

        If DisplayErrorMsg <> "" Then
            If bDisplayMsgBox Then
                MsgBox(DisplayErrorMsg, DisplayMsgBoxStyle)
            Else
                Console.WriteLine(DisplayErrorMsg)
            End If
        End If

    End Sub

End Module
